Subject: Re: [PATCH RFC] spinlock: split out debugging check from spin_lock_mutex

From: Bart Van Assche <[email-masked]>
Date: Sat, 13 Apr 2013 09:35:07 +0200

On 04/12/13 20:45, Neil Horman wrote:
> On Fri, Apr 12, 2013 at 04:01:04PM +0200, Bart Van Assche wrote:
>> On 04/12/13 13:32, Neil Horman wrote:
>> I think there is another issue with invoking mutex_trylock() and mutex_unlock()
>> from IRQ context: as far as I can see if CONFIG_DEBUG_MUTEXES is disabled
>> __mutex_unlock_common_slowpath() uses spin_lock() to lock mutex.wait_lock and
>> hence invoking mutex_unlock() from both non-IRQ and IRQ context is not safe.
>> Any thoughts about that ?
>>
> Yeah, its ugly, but in this specific case, its ok.  the netpoll code (in
> netpoll_send_skb disables irq on the local cpu before entering the netpoll code
> path any further, so whenver we frob this mutex from the local cpu, we're
> guaranteed not to get pre-empted by an irq.

As far as I know it is neither allowed nor safe to call 
netpoll_rx_disable() with IRQs disabled. But that function can lock the 
dev_lock mutex. What do you think will happen with 
CONFIG_DEBUG_MUTEXES=n if an interrupt occurs during the 
mutex_lock(&ni->dev_lock) call, that mutex_lock() call has already 
locked the mutex-internal spin lock via spin_lock() and mutex_trylock() 
is invoked from inside the interrupt ? Can that result in anything else 
than deadlock and "CPU stuck" messages ?

Thanks,

Bart.